package ambientMorality;

import rayTrace.Box;
import rayTrace.Collection;
import rayTrace.Dish;
import rayTrace.Element;
import rayTrace.Lens;
import rayTrace.Ray;
import rayTrace.Square;
import support.AsciiMatrixFile;

public class smallTest {
	final static double reHitTolerence = 1e-6;
	
	public static void main(String[] args) {
		test2();
	}
	
	/**
	 * @param args
	 */
	public static void test1() {
		// TODO Auto-generated method stub

		int nHits = 1000;
		double ang = 30 * Math.PI / 180;
		
		
		Dish dish1 = new Dish(new double[]{ -2.05, 0, 0}, new double[]{1, 0, 0}, 1, 0.6, Element.MATTYPE_TRANSPARENT, 2.0,1, reHitTolerence);
		Dish dish1b = new Dish(new double[]{ -1.95, 0, 0}, new double[]{-1, 0, 0}, 1, 0.6,  Element.MATTYPE_TRANSPARENT, 2.0,1, reHitTolerence);
		Dish dish2 = new Dish(new double[]{  2, 0, 0}, new double[]{-Math.cos(ang), Math.sin(ang), 0}, 2, 1, Element.MATTYPE_REFLECTING ,1,1, reHitTolerence);
		Box boundBox = new Box(new double[]{-3, -1.5, -1.5}, new double[]{ 3, 1.5, 1.5}, Element.MATTYPE_REFLECTING, 1,1, reHitTolerence);
		Box box = new Box(new double[]{-1.5, -1.0, -1.5}, new double[]{ -1.0, -0.5, 1.5}, Element.MATTYPE_TRANSPARENT, 2.0,1, reHitTolerence);
		
		Lens lens = new Lens(new double[]{ 0.0, 0.0, 0.0 }, new double[]{ 0.0, 1.0, 0.0}, 0.5, 0.4, Element.MATTYPE_TRANSPARENT, 1.0, 1.0, reHitTolerence );
		Square sq1 = new Square( new double[]{ -0.1, -0.0, 0.0}, new double[]{ 1.0, 0.0, 0.0}, new double[]{ 0.0, 1.0, 0.0}, 2, 4, Element.MATTYPE_REFLECTING , 1,1, reHitTolerence);
		Square sq2 = new Square( new double[]{ 0.1, -0.0, 0.0}, new double[]{ -1.0, 0.0, 0.0}, new double[]{ 0.0, 1.0, 0.0}, 2, 4, Element.MATTYPE_REFLECTING , 1,1, reHitTolerence);
		Collection lensInTube = new Collection(new Element[]{ lens,sq1,sq2 });
		lensInTube.rotateOnZ(new double[]{ 0,0,0}, 90.0 * Math.PI/180.0);
		lensInTube.shift(new double[]{ 1.0, -1.0, 0.0 });
		
		Collection coll = new Collection(new Element[]{ dish1,dish1b,dish2, boundBox, box, lensInTube});
			
		//dish1.rotateOnZ(new double[]{-1,0,0}, 90 * Math.PI / 180);
		
		Ray ray = new Ray(new double[]{ 0, 0, 0}, new double[]{-Math.cos(ang), Math.sin(ang), 0});
		
		double hits[][] = ray.traceRay(coll,nHits,null);
		
		AsciiMatrixFile.mustWrite("/work/scrap/amTest.txt",hits);
	} //*/
	
	public static void test2() {

		int nRays = 1000;
		double ang = 30 * Math.PI / 180;
		
		Square sq = new Square( new double[]{ 1.0, 0.0, 0.0}, new double[]{ -1.0, 0.0, 0.0}, new double[]{ 0.0, 0.0, 1.0}, 2, 4, Element.MATTYPE_REFLECTING , 1,1, reHitTolerence);
		double hits[][] = new double[nRays][3];
		
		for(int i=0;i<nRays;i++){
			double start[] = new double[]{ 0,0,0 };		
			Ray ray = Ray.generateRandomRayTowardSurface(start, sq);
			
			double hData[][] = ray.traceRay(sq, 1, null);
			if(hData != null)
				System.arraycopy(hData[1], 0, hits[i], 0, 3);
		}
		
		AsciiMatrixFile.mustWrite("/work/scrap/rayGenTest.txt",hits);
	} //*/
	
	


}
